// AP Computer Science Marine Biology Case Study program
// Copyright (C) 2000  College Board and Educational Testing Service
// Copyright (C) 2013  Michael H. Goldwasser

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// fishsim.cpp - copyright statement added 5/31/2000
// changed to use std string class, mhg 1/8/2013
// changed to allow filename as optional command line argument, mhg 2/5/2013

#include "display.h"
#include "environ.h"
#include "simulate.h"
#include <iostream>
#include <fstream>
#include <string>
using namespace std;

int main(int argc, char* argv[])
{
  ifstream input;

  // filename can be given as optional command line argument
  // (otherwise "fish.dat" is used as default)
  if (argc > 1) {
      input.open(argv[1]);
  } else {
      input.open("fish.dat");   // the default filename
  }

  Environment env(input);

  // Display display(100,100); // for graphics display
  Display display; // for text display
  string s;

  Simulation sim;

  int step;
  int numSteps;

  display.Show(env);

  cout << "--- initialized --- " << endl;

  cout << "How many steps? ";
  cin >> numSteps;
  getline(cin, s);

  for (step = 0; step < numSteps; step++)
  {
    sim.Step(env);
    display.Show(env);
    cout << " step " << step << " (press return)";
    getline(cin, s);
  }

  return 0;
}
